<?php

/**
 * THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR IMPLIED
 * WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 *
 * @package clearFusionCMS\module\dashrssfeed
 * @copyright Copyright (c) 2013 clearFusionCMS. All rights reserved.
 * @link http://clearfusioncms.com
 */

/**
 * dashrssfeedEvents Class
 *
 * Class to process dashboard RSS feed module events.
 *
 * @package clearFusionCMS\module\dashrssfeed
 */
class dashrssfeedEvents {

	/**
	 * Event handler for cron to draw the feed.
	 *
	 * @param flEvent $evt The event object.
	 */
	function onManagerBlock($evt) {
		if($evt->getParam('blockID') == 'cfdashrssfeed') {
			$cfg = new flConfigDb('cfdashrssfeed', clearFusionCMS::getDb());
			$var = new flVariables('cfdashrssfeed', clearFusionCMS::getDb());
			if(!empty($cfg->uri) && !empty($var->feed)) {
				new flRssClient(null);
				$feed = unserialize($var->feed);
				$html = '<ul class="rssfeed">';
				foreach($feed->items as $item) {
					$date = new flDate();
					$date = $date->timeSpan($item->pubDate);
					$html .= "<li><a href=\"" . $item->link . "\">" . $item->title . "</a><div>" . $item->description . "</div><span>$date[string]</span></li>\n";
				}
				$html .= "</ul>\n";

				$evt->setParam('content', $html);
				$evt->setParam('title', $cfg->title);
				$evt->setParam('size', 8); // An n icon block

				// Add the CSS
				$evt->getParam('tplEngine')->getCodeBuffer()->bufferCSS('system/modules/dashrssfeed/style.css');
			}
		}
	}

	/**
	 * Event handler for cron to fetch feed updates.
	 */
	function onCron() {
		$cfg = new flConfigDb('cfdashrssfeed', clearFusionCMS::getDb());
		if(!empty($cfg->uri)) {
			$rss = new flRssClient(null);
			if($channel = $rss->fetch($cfg->uri, 3)) {
				$var = new flVariables('cfdashrssfeed', clearFusionCMS::getDb());
				$var->feed = serialize($channel);
			}
		}
	}
}
